/*
dev/fifo.c
*/

#include <asm/system.h>
#include <asm/io.h>
#include <phantom/fifo.h>
#include <sys/types.h>

int
fifo_getc (char *src, int *index)
{
  int ret, i;
  ulg fl;

  if (!*index)
    return (-1);

  get_flags(fl);
  cli ();
  ret = *src;
  (*index)--;
  for (i = 0; i < *index; i++)
    src[i] = src[i + 1];
  set_flags(fl);

  return (ret);
}

int 
fifo_putc (int c, char *dst, int *index, int limit, int mode)
{
  int i;
  ulg fl;

  if (!limit)
    return (-1);

  get_flags(fl);
  cli();
  if (*index >= limit)
    {
      *index = limit;
      if (mode != FIFO_ROLL)
	return (-1);

      (*index)--;
      for (i = 0; i < *index; i++)
	dst[i] = dst[i + 1];
    }

  dst[(*index)++] = c;
  set_flags(fl);
  
  return (0);
}
