/*
  dev/fifo.c
  FIFO queuing.
*/

#include <asm/system.h>
#include <asm/io.h>
#include <phantom/fifo.h>
#include <sys/types.h>

struct fifo
{
unsigned char *data;
int limit;
int index;
int fl_locked;
};

int
fifo_getc (struct fifo *fifo)
{
  int ret, i;

  if (!fifo->index)
    return -1;  

  ret = fifo->data[0];
  for (i = 1; i < fifo->index; i++)
    fifo->data[i - 1] = fifo->data[i];

  fifo->index--;

  return ret;
}

int 
fifo_putc (struct fifo *fifo)
{
  int i;

  if(fifo->limit <= 0)
    return -1;

  if (fifo->index >= fifo->limit)
    {
      fifo->index = fifo->limit;
      if (fifo->mode != FIFO_ROLL)
	return -1;

      for (i = 1; i < fifo->index; i++)
	dst[i - 1] = dst[i];
    }

  fifo->data[fifo->index++] = c;
  
  return 0;
}
