/*
dev/null.c
Null file (/dev/null) driver.

TODO: check output area validity :)
*/

#include <phantom/fs.h>
#include <phantom/dfs.h>
#include <phantom/major.h>
#include <string.h>

#define MAJOR_NR	NULL_MAJOR

int
null_read (struct file *file, char *buff, size_t count)
{
#ifdef NULLDEBUG
  printk ("null_read: vnode=0x%x  file=0x%x  buff=0x%x  count=%d\n");
#endif
  bzero (buff, count);
  /* We could update f_pos, too... But lseek is not working
     since vnode->v_size is zero... */
  return count;
}

int
null_write (struct file *file, char *buff, size_t count)
{
#ifdef NULLDEBUG
  printk ("null_write: being called - why?\n");
#endif
  return count;			/* all is ok */
}

struct file_operations null_fops = {
  NULL,				/* lseek */
  null_read,
  null_write,
  NULL,				/* readdir */
  NULL,
  NULL,
  NULL				/* close */
};

void
null_init ()
{
  register_chrdev (MAJOR_NR, "null-dev", &null_fops);
  dfs_add ("null", MKDEV (MAJOR_NR, 0), S_IRWXU | S_IFCHR);
}
