/*
   fs/dfs/super.c
 */

#include <phantom/major.h>
#include <errno.h>
#include <phantom/buffer.h>
#include <phantom/dfs.h>
#include <phantom/fs.h>

struct super_block *dfs_super;
int dfs_read_vnode (struct vnode *vnode);

struct super_operations dfs_super_operations = {
  dfs_read_vnode,		/* read vnode */
  NULL,				/* write vnode */
  NULL				/* release super */
};

int
dfs_read_super (struct super_block *sb)
{
  struct vnode *vnode;

#ifdef DFS_DEBUG
  printk ("dfs_readsuper\n");
#endif

  sb->s_dev = 0;
  sb->s_op = &dfs_super_operations;
  vnode = vnode_get (sb, DFS_ROOT_VNODE_NUMBER);
  vnode->v_size = 0;
  vnode->v_dev = 0;
  vnode->v_mode = S_IFDIR | S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH;
  sb->s_mount = vnode;
  dfs_super = sb;
  return 0;
}
