#ifndef I386_KERNEL_H
#define I386_KERNEL_H

#define	KERNEL_CS		0x08
#define	KERNEL_DS		0x10


#define USER_CS			0x1B
#define USER_DS			0x23
#define USER_SS			0x07		/* first ldt entry,  RPL = 3 */

#define SETUP_SEG		0x9000
#define BOOT_OFS		0x7c00

#define KERNEL_SEG		0x1000
#define KERNEL_HEADER		"core"
#define KERNEL_HEADER_SIZE	4
#define KERNEL_OFFSET		0x10000

#define MEM_INFO		0x0	/* 4 */
#define PS2_MOUSE		0x4	/* 4 */
#define MONO_INFO		0x8	/* 4 */
#define ROOT_DEV		0x0C	/* 4 */
#define RAMDISK_BLOCK		0x10	/* 4 */
#define RAMDISK_BLOCKS		0x14	/* 4 */
#define RAMDISK_BASE		0x18	/* 4 */
#define VIDEO_MODE		0x1C	/* 4 */
#define KERNEL_TEXT_PAGES	0x20	/* 4 */
#define KERNEL_PAGES		0x24	/* 4 */	/* +bss pages */

#define SYSINFO_SIZE	40
#define SYSINFO_DWORDS	10

#define SQUEUE_EMPTY	0x00
#define SQUEUE_PENDING	0x01
#define SQUEUE_RUNNING	0x02

#endif
