#ifndef I386_REGDUMP_H
#define I386_REGDUMP_H

#include <sys/types.h>

/* common use -- most exceptions */
struct regdump
  {
    u32 ebx;
    u32 ecx;
    u32 edx;
    u32 esi;
    u32 edi;
    u32 ebp;
    u32 eax;
    u16 ds, ds2;
    u16 es, es2;
    u16 fs, fs2;
    u16 gs, gs2;
    u32 error_code;
    u32 eip;
    u16 cs, cs2;
    u32 eflags;
    u32 esp;
    u16 ss, ss2;
  };

/* defined in kernel/trap.c */
extern void printregdump (const char *title, struct regdump *regs);

#endif
