#ifndef I386_SYSTEM_H
#define I386_SYSTEM_H

#define nop() __asm__ __volatile__ ("nop")
#define xchg(ptr,x) ((__typeof__(*(ptr)))__xchg((unsigned long)(x),(ptr),sizeof(*(ptr))))
#define tas(ptr) (xchg((ptr),1))
#define mb()  __asm__ __volatile__ (""   : : :"memory")
#define sti() __asm__ __volatile__ ("sti": : :"memory")
#define cli() __asm__ __volatile__ ("cli": : :"memory")

#define get_flags(x) \
__asm__ __volatile__("pushfl ; popl %0":"=g" (x): /* no input */ :"memory")

#define set_flags(x) \
__asm__ __volatile__("pushl %0 ; popfl": /* no output */ :"g" (x):"memory")

#define iret() __asm__ __volatile__ ("iret": : :"memory")

/* user stack "starts" at 0x00000000 */
/* stack: ss, esp, cs, eip */
#define switch_to_user() \
__asm__ __volatile__ \
       ("pushl %0\n" \
	"pushl $0\n" \
        "pushfl\n" \
	"pushl %1\n" \
	"pushl $1f\n" \
	"iret\n" \
	"1:\n" \
	"movl %0,%%eax\n" \
	"mov %%ax,%%ds\n" \
	"mov %%ax,%%es\n" \
	"mov %%ax,%%fs\n" \
	"mov %%ax,%%gs\n" \
	:: "i" (USER_DS), "i" (USER_CS))

/* defined in kernel/main.c */
extern void system_exit(int);

#endif
