/*
   phantom extended console i/o
 */

#ifndef CONIO_H
#define CONIO_H

#include <stdio.h>
#include <sys/ttyio.h>
#include <phantom/kb.h>
#include <phantom/keyb.h>

#define ATTR(f,b)		(((b)<<4)|(f))
#define attr(a)			setattr(a)

#define    BLACK		0
#define    BLUE			1
#define    GREEN		2
#define    CYAN			3
#define    RED			4
#define    MAGENTA		5
#define    BROWN		6
#define    LIGHTGRAY		7
#define    GRAY			LIGHTGRAY
#define    DARKGRAY		8
#define    LIGHTBLUE		9
#define    LIGHTGREEN		10
#define    LIGHTCYAN		11
#define    LIGHTRED		12
#define    LIGHTMAGENTA		13
#define    YELLOW		14
#define    WHITE		15

#define	BRIGHTGRAY	LIGHTGRAY
#define	BRIGHTBLUE	LIGHTBLUE
#define BRIGHTGREEN	LIGHTGREEN
#define BRIGHTCYAN	LIGHTCYAN
#define BRIGHTRED	LIGHTRED
#define BRIGHTMAGENTA	LIGHTMAGENTA

#define DEFAULT_ATTR		LIGHTGRAY
#define INVERSE_ATTR		LIGHTGRAY<<4

#ifndef FALSE
#define FALSE		0
#endif
#ifndef TRUE
#define TRUE		1
#endif

#define TERMBASE		putchar('\033');\
				putchar('[')\

#define gotoxy(x,y)		{ TERMBASE;\
				putchar('m');\
				putchar(x);\
				putchar(y);}
#define move(y,x)		gotoxy((x),(y))
#define attrset(a)		{TERMBASE;\
				putchar('a');\
				putchar(a);}
#define setattr(a)		attrset(a)
#define textattr(a)		attrset(a)
#define bgcolor(c)		{printf("\033[b");\
				putchar(c);}
#define textcolor(c)		{printf("\033[t");\
				putchar(c);}
#define clrscr()		printf("\033[c")
#define typechar(c)		{printf("\033[T");\
				putchar(c);}
#define setchar(c)		{printf("\033[S");\
				putchar(c);}
#define flush_keyboard()	printf("\033[f")
#define cprintf			printf


#ifndef __KERNEL__
#define readkey()		ioctl(*stdout, TTY_READKEY, 0)
#define getkey(c)		ioctl(*stdout, TTY_GETKEY, (unsigned int)(c))
#define kbhit()			ioctl(*stdin, TIOC_KBHIT, 0)
#define getcursorx()		ioctl(*stdout, TTY_GETCURSOR, TTY_ACX)
#define getcursory()		ioctl(*stdout, TTY_GETCURSOR, TTY_ACY)
#endif

#endif
