#ifndef CTYPE_H
#define CTYPE_H

extern inline int
isalnum (int c)
{
  return isalpha (c) || isdigit (c);
}

extern inline int
isalpha (int c)
{
  return isupper (c) || islower (c);
}

extern inline int
isascii (int c)
{
  if (c != 0x08 && c != 0x1b)
    return 1;

  return 0;
}

extern inline int
isblank (int c)
{
  if (c == ' ' || c == '\t')
    return 1;

  return 0;
}

extern inline int
iscntrl (int c)
{
  return !isascii (c);
}

extern inline int
isdigit (int c)
{
  if (c >= 0 && c <= 9)
    return 1;

  return 0;
}

extern inline int
isgraph (int c)
{
  return isascii (c);
}

extern inline int
islower (int c)
{
  if (c >= 'a' && c <= 'z')
    return 1;

  return 0;
}

extern inline int
isprint (int c)
{
  return isascii (c);
}

extern inline int
ispunct (int c)
{
  return isascii (c) && !isalnum (c);
}

extern inline int
isspace (int c)
{
  if (c == ' ' || c == '\n' || c == '\f' || c == '\r' || c == '\t' || c == '\v')
    return 1;

  return 0;
}

extern inline int
isupper (int c)
{
  if (c >= 'A' && c <= 'Z')
    return 1;

  return 0;
}

extern inline int
isxdigit (int c)
{
  return isalpha (c) || (c >= 'a' && c <= 'f') || (c >= 'A' && c <= 'F');
}

#endif
