#ifndef ATAFLO_H
#define ATAFLO_H

#include <sys/types.h>

#define F_BOPEN         0x0001	/* The block device is opened */
#define F_MEDIA_CHANGED 0x0002	/* The media have changed since open */

struct floppy_cap_st
  {
    word data_length;
    byte medium_type;
#define MDT_UNKNOWN     0x00
#define MDT_NO_DISC     0x70
#define MDT_DOOR_OPEN   0x71
#define MDT_FMT_ERROR   0x72
    unsigned reserved0:7;
    unsigned wp:1;
    byte reserved1[4];

    unsigned page_code:6;	/* Page code - Should be 0x5 */
#define FLOPPY_CAP_PAGE        0x05
    unsigned reserved1_6:1;	/* Reserved */
    unsigned ps:1;		/* The device is capable of saving the page */
    byte page_length;		/* Page Length - Should be 0x1e */
    word transfer_rate;		/* Kbs */
    byte hd, sec;
    word block_size;
    word cyl;			/* Number of cylinders */
    word reserved10[10];
    byte motor_delay;		/* Motor off delay */
    byte reserved21[7];
    word rpm;
    byte reserved30[2];
  };

struct floppy_info
  {
    int flags;			/* device state flags */
    int max_blocks;		/* transfer size limit */
    struct floppy_cap_st cap;
  };

#endif
