#ifndef AUDIO_H
#define AUDIO_H

#define MODE_STEREO	0x01
#define MODE_16BIT	0x02

#define MAXMIXSTEP	2048	/* maximal mixer step */

extern int mixer_step;

struct voice_st
  {
    char *data;
    char mode;			/* data format, play mode, see above */
    int freq;
    int div;
    int size;
    int pos;
    char used;
    char loop;
  };

struct audio_driver
  {
    char *name;
    int (*setup) (int, int, unsigned char **, int *);
    int (*close) ();
    int (*getpos) ();
  };

#endif
