#ifndef BUFFER_H
#define BUFFER_H

#include <sys/types.h>

#define	NORMAL_DIRTYNESS		1
#define URGENT_DITRYNESS		2

struct bhead
  {
    int dev;			/* parent device */
    int used;			/* how many times used */
    int blocksize;		/* blocksize in bytes */
    int block_nr;		/* block number */
    int fl_dirty;		/* dirty (1) or not (0) */
    int fl_lock;		/* locked (1) or not (0) */
    int fl_uptodate;		/* uptodate (1) or not (0) */
    unsigned char *data;	/* one block data */
    unsigned int bp;		/* bpage pointer & index */
    struct bhead *next;		/* next buffer of device */
    struct bhead *prev;		/* previous buffer of device */
    struct bhead *next_free;	/* buffer/page with free space */
    struct bhead *next_dev;	/* next device queue */
    struct bhead *prev_dev;	/* previous device queue */
  };

extern struct bhead *bempty (int, int);
extern struct bhead *bread (int, int);
extern void brelse (struct bhead *);

#endif
