#ifndef EXT_H
#define EXT_H

#define NR_EXT		0x10

/* exts must be unique == defined only here... */
#define KB_EXT		0x00
#define PACKET_EXT	0x01

#include <sys/types.h>

extern u32 ext_mask;
extern u32 ext_active;

extern inline void
ext_run (int ext_nr)
{
  __asm__ __volatile__ ("orl %1,%0":"=m" (ext_active):"ir" (1 << ext_nr));
}

extern inline void
ext_enable (int ext_nr)
{
  __asm__ __volatile__ ("orl %1,%0":"=m" (ext_mask):"ir" (1 << ext_nr));
}

extern inline void
ext_disable (int ext_nr)
{
  __asm__ __volatile__ ("andl %1,%0":"=m" (ext_mask):"ir" (~(1 << ext_nr)));
}

extern void (*ext_table[NR_EXT]) (void);

#endif
