/*

   include/fat_fs.h

   Used only by fs.h.
   Internal fat definitions for fs/fat/* are in fat.h.

 */

#ifndef FAT_FS_H
#define FAT_FS_H

#include <phantom/buffer.h>

struct fat_super_info
  {
    char type;			/* 12, 16, 32 */
    char fatcount;		/* number of fat copies */
    char clusterblocks;		/* blocks to create cluster */
    char *table_dirt;		/* for fats synchronization */
    unsigned int fatentries;	/* total single-fat entries */
    unsigned short reserved;	/* reserved sectors -- boot sector */
    unsigned short fatsectors;	/* blocks per fat */
    unsigned int rootentries;	/* entries per root */
    unsigned int hidden;	/* 'hidden' blocks - mbr, etc. */
    unsigned int size;		/* total volume size in blocks (?) */
    unsigned int rootentrypos;	/* starting block of root */
    unsigned int datastart;	/* sector of first cluster */
    unsigned int itemcount;	/* count of diritems in one block */
    unsigned int rootdircluster; /* fat32 only -- independent root... */
  };

struct fat_vnode_info
  {
    u32 cluster;
  };

#endif
