#ifndef ASM_KEYBOARD_H
#define ASM_KEYBOARD_H

#define KB_DATA_REG		0x60
#define KB_STATUS_REG		0x64

#define KB_STAT_OBF 		0x01	/* Keyboard output buffer full */
#define KB_STAT_IBF 		0x02	/* Keyboard input buffer full */
#define KB_STAT_SELFTEST	0x04	/* Self test successful */
#define KB_STAT_CMD		0x08	/* Last write was a command write (0=data) */
#define KB_STAT_UNLOCKED	0x10	/* Zero if keyboard locked */
#define KB_STAT_MOUSE_OBF	0x20	/* Mouse output buffer full */
#define KB_STAT_GTO 		0x40	/* General receive/xmit timeout */
#define KB_STAT_PERR 		0x80	/* Parity error */

#define KB_CMD_DISABLE		0xAD
#define KB_CMD_ENABLE		0xAE

#define KB_DTA_LEDS		0xED	/* set leds */
#define KB_DTA_REENABLE		0xF4

#define NR_KEY			0x80

#endif
