#ifndef PHANTOM_UNISTD_H
#define PHANTOM_UNISTD_H

#include <errno.h>
#include <sys/types.h>
#include <phantom/sys_enum.h>

#define _syscall0(type,name) \
type name(void) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name)); \
if(__res>=0) \
  return((type)__res); \
errno=-__res; \
return(-1); \
}

#define _syscall1(type,name,type1,arg1) \
type name(type1 arg1) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1))); \
if(__res>=0) \
  return((type)__res); \
errno=-__res; \
return(-1); \
}

#define _syscall2(type,name,type1,arg1,type2,arg2) \
type name(type1 arg1,type2 arg2) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2))); \
if(__res>=0) \
  return((type)__res); \
errno=-__res; \
return(-1); \
}

#define _syscall3(type,name,type1,arg1,type2,arg2,type3,arg3) \
type name(type1 arg1,type2 arg2,type3 arg3) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
		  "d" ((long)(arg3))); \
if(__res>=0) \
  return((type)__res); \
errno=-__res; \
return(-1); \
}

#define _syscall4(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4) \
type name (type1 arg1, type2 arg2, type3 arg3, type4 arg4) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
	  "d" ((long)(arg3)),"S" ((long)(arg4))); \
if(__res>=0) \
  return((type)__res); \
errno=-__res; \
return(-1); \
} 

#define _syscall5(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4, \
	  type5,arg5) \
type name (type1 arg1,type2 arg2,type3 arg3,type4 arg4,type5 arg5) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
	  "d" ((long)(arg3)),"S" ((long)(arg4)),"D" ((long)(arg5))); \
if(__res>=0) \
  return((type)__res); \
errno=-__res; \
return(-1); \
}

#define _vsyscall0(type,name) \
type name() \
{ \
__asm__ volatile ("int $0x80" \
	: \
	: "a" (__NR_##name)); \
}

#define _vsyscall1(type,name,type1,arg1) \
type name(type1 arg1) \
{ \
__asm__ volatile ("int $0x80" \
	: \
	: "a" (__NR_##name),"b" ((long)(arg1))); \
}

#define _vsyscall2(type,name,type1,arg1,type2,arg2) \
type name(type1 arg1, type2 arg2) \
{ \
__asm__ volatile ("int $0x80" \
	: \
	: "a" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2))); \
}

#define _nsyscall1(type,name,type1,arg1) \
type name(type1 arg1) \
{ \
type __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1))); \
return(__res); \
}

#define _nsyscall2(type,name,type1,arg1,type2,arg2) \
type name(type1 arg1,type2 arg2) \
{ \
type __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2))); \
return(__res); \
}

#define _nsyscall4(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4) \
type name (type1 arg1, type2 arg2, type3 arg3, type4 arg4) \
{ \
type __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
	  "d" ((long)(arg3)),"S" ((long)(arg4))); \
return(__res); \
} 

#define _ren_syscall1(type,name1,name2,type1,arg1) \
type name1(type1 arg1) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name2),"b" ((long)(arg1))); \
if(__res>=0) \
  return((type)__res); \
errno=-__res; \
return(-1); \
}

#define _ren_syscall3(type,name1,name2,type1,arg1,type2,arg2,type3,arg3) \
type name1(type1 arg1,type2 arg2,type3 arg3) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name2),"b" ((long)(arg1)),"c" ((long)(arg2)), \
		  "d" ((long)(arg3))); \
if(__res>=0) \
  return((type)__res); \
errno=-__res; \
return(-1); \
}


#endif
