#ifndef TTY_H
#define TTY_H

#include <phantom/wait.h>

#define NR_TTY			8
#define DEFAULT_RG_TTY		6	/* red gui's */
#define DEFAULT_PRINTK_TTY	7	/* last one */

#define	FL_NONE		0	/* keyboard flags */
#define	FL_SHIFT	1
#define	FL_CAPS		2
#define	FL_CTRL		4
#define	FL_ALT		8
#define FL_SCROLL	16

#define	LED_NONE	0
#define	LED_SCROLL	1
#define	LED_NUM		2
#define	LED_CAPS	4

#define	DEFAULT_KBLEDS		LED_NONE
#define DEFAULT_KBFLAGS		FL_NONE
#define KB_BUFFSIZE		32

#define CURRENT_TTY_MINOR	0xFF

/* cursor mode values */
#define TTY_NOCURSOR		0x01
#define TTY_SMALLCURSOR		0x02
#define TTY_BIGCURSOR		0x03

struct tty
{
  int expect2, expect, buff[3];	/* buff for aguments */
  int cursor_x, cursor_y;	/* cursor position */
  int size_x, size_y;		/* terminal sizes */
  int cursor_mode;		/* cursor shape/visibility */
  int attr;			/* attribute */
  int gr_mode;			/* current graphic mode */
  unsigned char *screen;	/* screen data */
  struct video_driver *vdriver;	/* video device/driver */

/* INPUT SECTION */
  unsigned char kb_buff[KB_BUFFSIZE];
  int kb_buff_i;			/* buffers' index */
  unsigned char raw_buff[KB_BUFFSIZE];	/* phantom codes */
  int kb_leds;
  int kb_flags;
  
  WAIT *key_wait;
};

typedef struct tty TTY;

extern TTY *current_tty;
extern TTY *printk_tty;
extern TTY *rg_tty;

void term_send (TTY * t, char *s, int count);

#include <phantom/video.h>

#endif
