#ifndef VIDEO_H
#define VIDEO_H

#include <phantom/tty.h>

struct video_driver
{
  char *name;			/* driver name */
  void *screen_base;		/* gfx memory offset */
  void *backup_screen;		/* for currently used text tty */
  int mode;			/* gfx mode */
  int size_x;			/* x pixels/characters */
  int size_y;			/* y pixels/characters */
  int bpp;			/* bits per pixel */
  struct tty_video_operations *tty;
  struct general_video_operations *general;
};

struct tty_video_operations
{
  void (*draw_char) (TTY *, int);	/* draw current tty on screen */
  void (*clear_screen) (TTY *);
  void (*scroll_screen) (TTY *, int);
  void (*set_cursor) (TTY *);
  void (*switch_screen) (TTY *, TTY *);
  void (*shape_cursor) (TTY *);
};

/* tty must not act here in any way... */
struct general_video_operations
{
  int (*set_mode) (struct video_driver *, int);
/*int (*set_palette)(unsigned char *);*/
};

extern struct video_driver *vdriver;

#endif
