#ifndef RG_H
#define RG_H

#include <rg/window.h>
#include <rg/rgio.h>
#include <sys/ioctl.h>
#include <rg/event.h>
#include <phantom/kb.h>
#include <phantom/keyb.h>
#include <conio.h>

void rg_box(WINDOW *win, int x, int y, int lx, int ly, int attr);
void rg_putch(WINDOW *win, int x, int y, int a, int c);
int rg_boxprintf(WINDOW *win, int x, int y, int lx, int ly, int a, char *str, ...);
int rg_printf(WINDOW *w, int x, int y, int attr, char *text, ...);
void rg_wrefresh(WINDOW *win);
WINDOW *rg_newwin(int x, int y, int lx, int ly);
void rg_freewin(WINDOW *w);
void rg_wrefresh(WINDOW *);
int rg_getevent (WINDOW * w, EVENT * e);
void rg_strecho (WINDOW * w, int x, int y, int attr, char *text, int count);
void rg_setcursor (WINDOW * w, int x, int y);

int rg_iocmd(WINDOW *w, unsigned int cmd, unsigned int arg);

#define ACPAIR(a,c)	(((a) << 8) | (c))

#define rg_wrefresh(w)		rg_iocmd((w), RGIOWREFRESH, 0)
#define rg_showwin(w)		rg_iocmd((w), RGIOWSHOW, 0)
#define rg_hidewin(w)		rg_iocmd((w), RGIOWHIDE, 0)
#define rg_setcursormode(w,s)	rg_iocmd((w), RGIOCMODE, (s))

#define rg_showcursor(w)	rg_setcursormode((w), RG_SMALLCURSOR)
#define rg_showbigcursor(w)	rg_setcursormode((w), RG_BIGCURSOR)
#define rg_hidecursor(w)	rg_setcursormode((w), RG_NOCURSOR)

#define rg_getkey(x)		getkey(x)

#endif
