#ifndef STDIO_H
#define STDIO_H

#include <unistd.h>
#include <errno.h>
#include <stdarg.h>
#include <phantom/fs.h>

#define NR_FFILES	10

#define GETS_MAX	128

#ifndef EOF
#define EOF		-1
#endif

typedef int FILE;
typedef long fpos_t;

extern FILE *stdin;
extern FILE *stdout;
extern FILE *stderr;
extern long errno;			/* scalls.c */

#define is_printable(c)	((c) >= 32 && (c) <= 128)

#ifndef __KERNEL__

/* macros */
#define putch(c)		putchar((c))
#define getche()		getchar()
#define putchar(c)		putc((c), stdout)
#define puts(s)			printf("%d\n", s)

/* stdio.c */
extern int putc(int c, FILE *stream);
extern int fputs(char *s, FILE *stream);
extern int putc(int c, FILE *stream);
extern FILE *fopen(char *path, char *mode);
extern int fclose(FILE* stream);
extern size_t fread(void *buff,size_t count,size_t bsize,FILE *stream);
extern size_t fwrite(void *buff, size_t count, size_t bsize,FILE *stream);
extern int fseek(FILE *stream, long offset, int whence);
extern long ftell(FILE *stream);
extern void rewind(FILE *stream);
extern int fgetpos(FILE *stream, fpos_t *pos);
extern int fsetpos(FILE *stream, fpos_t *pos);
extern int getc(FILE *stream);
extern int getchar();
extern char *fgets(char *s,int size, FILE *stream);
int sprintf (char *buf, const char *fmt,...);
int vfprintf (FILE *, const char *fmt, va_list ap);
int printf (const char *fmt,...);
void perror (const char *);
int fflush (FILE *);

/* print.c */
/*
extern int printf(char *, ...);
extern int sprintf(char *, ...);
*/

/*extern int mount(char*,char*, char*);
extern int umount(char*);
*/
#endif
#endif
