#ifndef TYPES_H
#define TYPES_H

static inline unsigned short
wswap(unsigned short x)
{
	__asm__("xchgb %b0,%h0"
		: "=q" (x)
		:  "0" (x));
	return x;
}

extern inline unsigned long htonl(unsigned long _val)
{
  return (_val << 24) | ((_val&0xff00) << 8) | ((_val&0xff0000) >> 8) | (_val >> 24);
}
#define ntohl(x) htonl(x)

extern inline unsigned short htons(unsigned short _val)
{
  return (_val << 8) | (_val >> 8);
}
#define ntohs(x) htons(x)

#define MIN(a,b) ((a) < (b) ? (a) : (b))
#define MAX(a,b) ((a) > (b) ? (a) : (b))

//typedef unsigned char byte;
typedef signed char sbyte;
typedef unsigned char uchar;
typedef unsigned short word;
typedef signed short sword;
typedef unsigned int uint;
typedef unsigned int ulg;

typedef unsigned int	u32;
typedef int		s32;
typedef unsigned short	u16;
typedef short		s16;
typedef unsigned char	u8;
typedef char		s8;

typedef u32 	size_t;
typedef s32	time_t;
typedef s32	off_t;
typedef u16	dev_t;
typedef int	socklen_t;
typedef u32	uid_t;
typedef u32	gid_t;
typedef u32	mode_t;
typedef u32	ino_t;
typedef u32	sigset_t;
typedef u32	pid_t;

#ifndef NULL
#define NULL	((void *)0)
#endif

struct dirent
{
  unsigned short d_reclen;	/* maybe compatibility */
  char d_name[256];		/* FIXME: use PATH_MAX instead.. */
};

#endif
