#include <phantom/wait.h>
#include <phantom/sched.h>
#include <sys/types.h>
#include <asm/system.h>

void
waitfor (void *ptr)
{
  for (;;)
    {
      if (((u8 *) ptr)[0] & 1)	/* zero bit is one, okay... */
	return;

      schedule ();
    }
}

void 
waitforbyte (void *ptr)
{
  for (;;)
    {
      if (((u8 *) ptr)[0])
	return;

      schedule ();
    }
}

void 
sleep_on (WAIT ** stack, WAIT * wait)
{
  u32 fl;

  get_flags (fl);
  cli ();

  if (stack == NULL || wait == NULL)
    {
      set_flags (fl);
      return;
    }

  wait->next = *stack;
  *stack = wait;

  ctask->status = TASK_STOPPED;

  schedule ();

  set_flags (fl);
}

void 
wake_up (WAIT ** stack)
{
  u32 fl;

  get_flags (fl);
  if (stack == NULL || *stack == NULL)
    {
      set_flags (fl);
      return;
    }

  (*stack)->task->status = TASK_RUNNING;
  (*stack) = (*stack)->next;

  set_flags (fl);
}
