#include <phantom/list.h>

void
list_add (LIST * item, LIST ** head, LIST ** tail)
{
  if (*head == NULL)
    {
      *head = item;
      *tail = item;
      item->next = NULL;
      item->prev = NULL;
      return;
    }

  if (*tail == NULL)
    {
      printk ("list_add: broken queue, head=0x%x\n", *head);
      return;
    }

  (*tail)->next = item;
  item->prev = *tail;
  *tail = item;
  item->next = NULL;
}

void
list_head_add (LIST * item, LIST ** head, LIST ** tail)
{
  if (*head == NULL)
    {
      *head = item;
      *tail = item;
      item->next = NULL;
      item->prev = NULL;
      return;
    }

  if (*tail == NULL)
    {
      printk ("list_head_add: broken queue, head=0x%x\n", *head);
      return;
    }

  item->next = *head;
  (*head)->prev = item;
  *head = item;
  item->prev = NULL;
}

void
list_del (LIST * item, LIST ** head, LIST ** tail)
{
  if (item == NULL)
    {
      printk ("list_del: warning, NULL item given\n");
      return;
    }

  if (*head == item)
    *head = item->next;

  if (*tail == item)
    *tail = item->prev;

  item->prev = NULL;
  item->next = NULL;
}
