#define is_digit(c)	((c)>='0'&&(c)<='9')
#define is_smallhex(c)	((c)>='a'&&(c)<='f')
#define is_bighex(c)	((c)<='F'&&(c)>='A')
#define is_hexdigit(c)	(is_digit(c)||is_smallhex(c)||is_bighex(c))

int atoi (const char *s);
int tolower (int c);
int toupper (int c);

/*
   atoi
   converts string to integer (unsigned)
 */
int
atoi (const char *s)
{
  int res = 0;

  while (*s && !is_digit (*s))
    s++;

  if (s[0] == '0' && s[1] == 'x')
    {				/* hexi */
      s += 2;
      while (is_hexdigit (*s))
	{
	  if (is_digit (*s))
	    res = res * 0x10 + *s - '0';
	  else if (is_smallhex (*s))
	    res = res * 0x10 + *s - 'a' + 0xa;
	  else
	    res = res * 0x10 + *s - 'A' + 0xA;	/* bighex */

	  s++;
	}
      return res;
    }

/* decimal */
  while (is_digit (*s))		/* converting ... */
    res = res * 10 + *(s++) - '0';

  return res;
}

int
tolower (int c)
{
  if (c >= 'A' && c <= 'Z')
    return (c + ('a' - 'A'));
  else
    return (c);
}

int
toupper (int c)
{
  if (c >= 'a' && c <= 'z')
    return (c - ('a' - 'A'));
  else
    return (c);
}
