/*
phantom loopback device
*/

#include <phantom/netdev.h>
#include <phantom/route.h>

struct device lo;

int
lo_xmit (struct pkt_head *pkt)
{
#ifdef LODEBUG
  printk ("lo_xmit: pkt=0x%p\n", pkt);
#endif

  pkt_dequeue (pkt);
  pkt_rx (pkt);

  return 0;
}

void
lo_init ()
{
  lo.mtu = 576;
  lo.hw_hdr_len = 0;

  lo.pkt_tx = &lo_xmit;
  lo.name = "lo";

  lo.ip_addr[0] = 127;
  lo.ip_addr[1] = 0;
  lo.ip_addr[2] = 0;
  lo.ip_addr[3] = 1;

  route_add(&lo);
}
