#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

#define DEFAULT_DEV	"/dev/da0"

char *edit_dev = DEFAULT_DEV;

#define DOSPART struct dospart
#define NR_ROOTENTRIES	4

DOSPART
{
  u8 boot, bhead;
  u16 bseccyl;
  u8 system;
  u8 ehead;
  u16 eseccyl;
  u32 start, blocks;
};

char root_sector[512];
DOSPART *root = (DOSPART *) (root_sector + 0x1BE);

int
read_root ()
{
  int fd;

  fd = open (edit_dev, O_RDONLY);
  if (fd == -1)
    return -1;
  read (fd, root_sector, 512);
  close (fd);

  return 0;
}

void
part_print ()
{
  int i;

  printf ("Nr Bt Start  End  Blocks  Id\n");
  for (i = 0; i < NR_ROOTENTRIES; i++)
    printf ("%d %c  %8d  %8d  %8d %d\n", i, root[i].boot == 0x80 ? '*' : ' ',
	    root[i].start, root[i].start + root[i].blocks,
	    root[i].blocks, root[i].system);
}

void
part_delete (int i)
{
  bzero (&root[i], sizeof (DOSPART));
}

int
gain_number (char *str, int *res)
{
  int i;
  char buff[16];

  printf (str);
  fgets (buff, 15, stdin);
  if (*buff)			/* newline cutout */
    buff[strlen (buff) - 1] = '\0';

  i = atoi (buff);
  *res = i;

  return 0;
}

void
part_new ()
{



}

int
main (int argc, char **argv)
{
  int i, k;

  printf ("fdisk 1.0 04062001mo (ro version)\n");

  if (argc == 2)
    edit_dev = argv[1];

  printf ("assuming device/file %s\n", edit_dev);
  if (read_root ())
    {
      printf ("cannot read\n");
      return -1;
    }

  do
    {
      k = getchar ();

      switch (k)
	{
	case 'p':		/* print partition info */
	  part_print ();
	  break;

	case 'd':		/* delete partition */
	  if (gain_number ("delete partition nr: ", &i))
	    break;
	  part_delete (i);
	  break;

	case 'n':		/* new partition */
	  part_new ();
	  break;

	case '?':		/* help */
	  printf ("p  print partition info\n");
	  printf ("d  delete partition\n");
	  printf ("n  new partition\n");
	  printf ("q  quit fdisk\n");
	  printf ("?  print this help screen\n");

	  break;
	}
    }
  while (k != 'q');

  return 0;
}
