#include <errno.h>
#include "karzyk.h"

int del_dir(char *dname)
{
DIR *d;
char *s;
struct dirent *dent;
struct stat st;

d=opendir(dname);
if(d==NULL)
  {
   messagebox("Warning", "Cannot open directory.", OK_BUTTON);
   return -1;
  }

    if(chdir(dname))
     {
     closedir(d);
     return -1;
     }

while((dent = readdir(d))!=NULL)
  {
    s=dent->d_name;
    if(s[0]=='.' && (!s[1] || (s[1] == '.'&& !s[2])))
      continue;     /* skip dot, dots */

  if(stat(dent->d_name, &st))
    {
     closedir(d);
     return -1;
     }

  if(S_ISDIR(st.st_mode))
    {
    if(del_dir(dent->d_name))
      return -1;
    } else {    /* file or whatever */
           if(unlink(dent->d_name))
             return -1;
           }
  }

/* dir should be empty now... */
closedir(d);

 if(chdir(".."))                /* go back */
     return -1;

if(rmdir(dname))
  return -1;

return 0;
}

void delete_obj(CELL *c, TABLE *t, PANEL *p)
{
char buff[512], *fname;
struct stat st;

fname=p->dent[t->arow].d_name;

if(fname[0]=='.'&&fname[1]=='.'&&!fname[2])
  return;                          /* cannot operate on dots */

if(chdir(p->cur_dir))
  return;

if(stat(fname, &st))
  return;

if(!S_ISDIR(st.st_mode) && !S_ISREG(st.st_mode))
 return;

sprintf(buff, "Delete %s \"%s\" ?",
        S_ISDIR(st.st_mode) ? "directory" : "file", fname);
if(messagebox("Question", buff, OK_BUTTON | CANCEL_BUTTON)==CANCEL_BUTTON)
  return;

if(S_ISDIR(st.st_mode))
  {
   if(del_dir(fname))
     return;
   }

if(S_ISREG(st.st_mode))
  {
  if(unlink(fname))
    {
     messagebox("Warning", "Cannot unlink file.", OK_BUTTON);
      return;              /* nothing to sync */
    }
  }

scandir(".", p);
t->rows=p->count;

default_event_handler(c, EVENT_RESET, 0);
default_event_handler(c, EVENT_DRAW, 0);
}

void make_dir(CELL *c, TABLE *t, PANEL *p)
{
char buff[512];
int ret;
struct stat st;
PANEL *m;

buff[0]=0;
if(querybox("Make Directory", "Directory name", buff, 512)==NULL)
  return;

if(chdir(p->cur_dir))
  return;

retry:

if(!stat(buff, &st))
  {
  ret=messagebox("Warning", "Object already exists.\nTry again?",
  OK_BUTTON | CANCEL_BUTTON);

  switch(ret)
    {
     case OK_BUTTON:
       goto retry;

     case CANCEL_BUTTON:
       return;

    /*case IGNORE_BUTTON: */
    }
  }

if(mkdir(buff, S_IWUSR))
  {
   sprintf(buff, "Cannot create directory.\nerrno = %d", errno);
   messagebox("Warning", buff, OK_BUTTON);
   return;
  }

scandir(".", p);
t->rows=p->count;

default_event_handler(c, EVENT_RESET, 0);
default_event_handler(c, EVENT_DRAW, 0);

m=p->mate;
if(!strcmp(p->cur_dir, m->cur_dir))
  {
  default_event_handler(m->cell, EVENT_RESET, 0);
  default_event_handler(m->cell, EVENT_DRAW, 0);
  }
}

