/*
   Phantom Shell 1.1, 21081998fr1153, 10101998sa2251
 */

#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

#include <phantom/mouse.h>
#include <phantom/mouse_io.h>

#define VERSION		"1.2"
#define DATE		"10101998sa2251"
#define ID		"psh " VERSION ", " DATE

char curdir[PATH_MAX];
char homedir[PATH_MAX];

void psh_help ();

int fl_exit = 0;

struct command_struct
  {
    char *name, *help;
    void (*action) ();
  };

static char buff[128], args[5][25];
int argc;

void
dump (char *ofs, int len)
{
  int i, lines;

  lines = 0;
  putchar ('\n');
  do
    {
      printf ("%08x  %08x %08x %08x %08x  ", ofs, *((ulg *) ofs),
	      ((ulg *) ofs)[1], ((ulg *) ofs)[2], ((ulg *) ofs)[3]);
      setattr (INVERSE_ATTR);
      for (i = 0; i < 0x10; i++)
	typechar (*ofs++);
      setattr (DEFAULT_ATTR);
      putchar ('\n');
      lines++;
      len -= 0x10;
      if (lines == 22)
	{
	  if (!psh_more ())
	    return;
	  lines = 0;
	}
    }
  while (len > 0);
  if (len)
    printf ("sorry, %d bytes overrun\n", -len);
}

void
parse_args ()
{
  int i, j;
  for (i = 0; i < 5; i++)
    args[i][0] = 0;
  i = 0;
  argc = 0;
  for (;;)
    {
      while (buff[i] == ' ' && buff[i])
	i++;
      if (!buff[i])
	return;
      else
	{
	  j = 0;
	  while (buff[i] != ' ' && buff[i])
	    args[argc][j++] = buff[i++];
	  args[argc][j] = 0;
	  argc++;
	}
    }
}

int
psh_more ()
{
  int k;
  setattr (INVERSE_ATTR);
  printf (" more ");
  setattr (DEFAULT_ATTR);
  k = getch ();
  if (k == 'q' || k == 'Q')
    {
      putchar (8);
      putchar (8);
      putchar (8);
      putchar (8);
      putchar (8);
      putchar (8);
      return (0);
    }
  putchar (8);
  putchar (8);
  putchar (8);
  putchar (8);
  putchar (8);
  putchar (8);
  return (-1);
}

char *
getwd (char *buff)
{
  getcwd (buff, PATH_MAX);
  return (buff);
}
/*
   void
   psh_less ()
   {
   int fd, lines, i, fsize;
   char *buff;

   if ((fd = open (args[1], O_RDONLY)) < 0)
   {
   printf ("Could not open. errno=%d\n", -fd);
   return;
   }

   fsize = lseek (fd, 0, SEEK_END);
   printf ("file size=%d\n", fsize);

   if (!(buff = (char *) malloc (fsize, PG_KERNEL)))
   {
   printf ("psh_less: %d bytes is too long...\n", fsize);
   sys_close (fd);
   return;
   }

   sys_lseek (fd, 0, SEEK_SET);
   printf ("%d bytes read\n", sys_read (fd, buff, fsize));
   sys_close (fd);

   lines = 0;
   for (i = 0; i < fsize; i++)
   {
   typechar (buff[i]);
   if (i % 80 == 0)
   lines++;
   if (lines == 25)
   {
   if (!psh_more ())
   {
   kfree (buff);
   return;
   }
   lines = 0;
   }
   }
   putchar ('\n');
   kfree (buff);
   }
 */

void
psh_create ()
{
  int fd;

  printf ("Trying to create file %s.\n", args[1]);
  if ((fd = creat (args[1], 0)) < 0)
    {
      printf ("Cannot create...\n");
      return;
    }
  printf ("File created, fild=%d\n", fd);
}

void
psh_open ()
{
  int fd;
  printf ("Opening %s.\n", args[1]);
  if ((fd = open (args[1], O_RDONLY)) < 0)
    printf ("File %s was not found. (errno=%d)\n", args[1], errno);
  else
    printf ("Opened with fild = %d.\n", fd);
}

void
psh_close ()
{
  if (close (atoi (args[1])) < 0)
    printf ("Close failed.\n");
}

void
psh_rm ()
{
  int ret;

  if (ret = unlink (args[1]))
    {
      printf ("Cannot erase %s (errno=%d)\n", args[1], -ret);
      return;
    }
  printf ("File removed.\n");
}

void
psh_cat ()
{
  int fd, i, j, bts;
  char buff[512];		/* for faster reading :) */

  if (args[2][0])
    bts = atoi (args[2]);
  else
    bts = -1;

  if ((fd = open (args[1], O_RDONLY)) < 0)
    {
      fprintf (stderr, "cannot open %s\n", args[1]);
      return;
    }

  while (i = read (fd, buff, 512))
    {
      for (j = 0; j < i; j++)
	{
	  putchar (buff[j]);
	  if (bts != -1)
	    {
	      bts--;
	      if (!bts)
		goto cat_home;
	    }
	}
    }

cat_home:
  close (fd);
}

void
psh_cp ()
{
  int sfd, dfd, i;
  char buff[512];

  sfd = open (args[1], O_RDONLY);
  if (sfd < 0)
    {
      fprintf (stderr, "Cannot open source file.\n");
      return;
    }

  dfd = open (args[2], O_WRONLY);
  if (dfd < 0)
    {
      fprintf (stderr, "Cannot open dest file.\n");
      return;
    }

  while (i = read (sfd, buff, 512))
    {
      if (i != write (dfd, buff, i))
	{
	  fprintf (stderr, "Write trouble.\n");
	  break;
	}
    }

  close (sfd);
  close (dfd);
}

void
psh_seek ()
{
  int ret;

  ret = lseek (atoi (args[1]), atoi (args[2]), SEEK_SET);
  if (ret < 0)
    printf ("seek error, %d\n", ret);
  else
    printf ("seek ok, new position=%d\n", ret);
}

void
psh_tell ()
{
  int ret;

  ret = lseek (atoi (args[1]), 0, SEEK_CUR);
  if (ret < 0)
    printf ("tell error, errno=%d\n", -ret);
  else
    printf ("fd's %d position=%d\n", atoi (args[1]), ret);
}

void
psh_mount ()
{
  int ret;

  if (!args[1][0] || !args[2][0] || !args[3][0])
    {
      printf ("Invalid argument(s).\n");
      return;
    }

  printf ("Mounting %s ==> %s, filesystem=%s\n", args[1], args[2], args[3]);

  if (ret = mount (args[1], args[2], args[3], 0))
    printf ("mount failed, %d\n", ret);
  else
    printf ("Successfully mounted!\n");
}

void
psh_umount ()
{
  printf ("Unmounting %s\n", args[1]);

  if (!umount (args[1]))
    printf ("Successfully unmounted!\n");
  else
    printf ("Unable to unmount, errno=%d\n", errno);
}

void
perm_decay (int perm)
{
  if (perm & S_IFBLK)
    putchar ('b');
  else if (perm & S_IFDIR)
    putchar ('d');
  else if (perm & S_IFCHR)
    putchar ('c');
  else if (perm & S_IFLNK)
    putchar ('l');
  else if (perm & S_IROTH)
    putchar ('r');
  else
    putchar ('-');
  if (perm & S_IWOTH)
    putchar ('w');
  else
    putchar ('-');
  if (perm & S_IXOTH)
    putchar ('x');
  else
    putchar ('-');
}

void
psh_ls ()
{
  char c;
  int ret;
  struct dirent *dir;
  DIR *d;
  struct stat st;

  printf ("listing current directory\n");
  d = opendir (".");

  if (d == NULL)
    {
      printf ("cannot open the directory\n");
      return;
    }

  while (dir = readdir (d))
    {
      if (ret = stat (dir->d_name, &st))
	printf ("psh_ls: stat failed, name=%s, errno=%d\n", dir->d_name,
		errno);

      if (S_ISBLK (st.st_mode))
	c = 'b';
      else if (S_ISDIR (st.st_mode))
	c = 'd';
      else
	c = '-';		/* does c==0 terminate whole printf? */
      printf ("%16s  %8d  %c", dir->d_name, st.st_size, c);
      perm_decay ((st.st_mode >> 6) & 0x07);
      perm_decay ((st.st_mode >> 3) & 0x07);
      perm_decay (st.st_mode & 0x07);
      printf ("\n");
    }

  closedir (d);
}

void
psh_cd ()
{
  int ret;

  if (args[1][0] == '~' && !args[1][0])
    {
      chdir (homedir);
      return;
    }

  if (ret = chdir (args[1]))
    {
      ret = -ret;
      if (ret == ENOTDIR)
	printf ("not a directory\n");
      printf ("chdir failed, errno=%d\n", ret);
    }
}

void
psh_set ()
{


}

void
psh_clone ()
{
  int p;

  if (!args[1][0])
    {
      printf ("Invalid i/o device.\n");
      return;
    }

  switch (p = fork ())
    {
    case 0:
      close (0);
      close (1);
      close (2);

      open (args[1], O_RDWR);
      dup (0);
      dup (0);
      break;

    default:
      printf ("Cloned psh running at %s with pid %d\n", args[1], p);
      break;
    }
}

void
psh_run ()
{
  int p;

  switch (p = fork ())
    {
    case 0:
      if (args[2][0])		/* i/o redirection */
	{
	  close (0);
	  close (1);
	  close (2);

	  open (args[2], O_RDWR);

	  dup (0);
	  dup (0);
	}

      execve (args[1], NULL, NULL);
      break;

    default:
      if (!args[2][0])		/* wait if on same tty */
	{
	  printf ("Waiting till %s (pid=%d) dies...\n", args[1], p);
	  waitpid (p, NULL, 0);
	}
      break;
    }
}

void
psh_write ()
{
  int fd, i;

  fd = atoi (args[1]);
  i = strlen (args[2]);
  printf ("Writing %d bytes to fild %d.\n", i, fd);

  i = write (fd, args[2], i);
  if (i < 0)
    {
      printf ("errno=%d\n", -i);
      return;
    }
  else
    printf ("%d bytes written.\n", i);
}

void
psh_dup ()
{
  int fd = atoi (args[1]);

  printf ("duping %d\n", fd);
  printf ("dup returns %d\n", dup (fd));
}

void
psh_dump ()
{
  int start, len;

  start = atoi (args[1]);
  len = atoi (args[2]);

  printf ("dumping %d bytes at 0x%p\n", len, start);
  dump ((char *) start, len);
}

void
psh_termtest ()
{
  int i, j;
  char txt, bkg;

  txt = 7;
  bkg = 0;

  for (i = 0; i < 256; i++)
    typechar (i);

  printf ("\n\nPutting all characters.\n");
  for (i = 0; i < 256; i++)
    putchar (i);

  printf ("Test cursor keys (with shift).\n'q' to quit\n");
  while ((i = getch ()) != 'q')
    {
      switch (i)
	{
	case 1:
	  printf ("UP ");
	  break;
	case 2:
	  printf ("DOWN ");
	  break;
	case 3:
	  printf ("LEFT ");
	  break;
	case 4:
	  printf ("RIGHT ");
	  break;
	default:
	  putchar (i);
	  break;
	case 'b':		/* change background */
	  bkg++;
	  if (bkg == 0x10)
	    bkg = 0;
	  bgcolor (bkg);
	  break;
	case 't':		/* change text */
	  txt++;
	  if (txt == 0x10)
	    txt = 0;
	  textcolor (txt);
	  break;
	}
    }
  attrset (DEFAULT_ATTR);
}

void
psh_mousetest ()
{
  int fd;
  int x, y, b;

  fd = open (args[1], 0);
  if (fd == -1)
    {
      printf ("cannot open %s!\n", args[1]);
      return;
    }
  ioctl (fd, MIOC_ON, 0);

  while (!kbhit ())
    {
      x = ioctl (fd, MIOC_GETX, 0);
      y = ioctl (fd, MIOC_GETY, 0);
      b = ioctl (fd, MIOC_GETB, 0);
      printf ("[%d; %d] %c %c\n", x, y, b & MOUSE_BL ? 'x' : '.',
	      b & MOUSE_BR ? 'x' : '.');
    }
  (void) getch ();
  ioctl (fd, MIOC_OFF, 0);
  close (fd);
}

void
psh_mkdir ()
{
  mkdir (args[1], S_IRWXU);
}

void
psh_rmdir ()
{
  rmdir (args[1]);
}

void
psh_stat ()
{
  int ret;
  struct stat st;

  if (ret = fstat (atoi (args[1]), &st))
    {
      printf ("fstat fails, ret=%d\n", ret);
      return;
    }

  printf ("mode=0%o\n", st.st_mode);
}

void
psh_mwrite ()
{
  ulg ofs;

  ofs = atoi (args[1]);
  printf ("writing \"%s\" at 0x%p\n", args[2], ofs);
  strcpy ((char *) ofs, args[2]);
}

void
psh_touch ()
{
  int ret;
  if ((ret = open (args[1], O_RDWR | O_CREAT)) < 0)
    {
      printf ("touch fails, ret=%d\n", ret);
      return;
    }
  printf ("file created (fd=%d)\n", ret);
  close (ret);
}

void
psh_cls ()
{
  clrscr ();
}

void
psh_exit ()
{
  fl_exit = 1;
}

void 
psh_malloc ()
{
  int i;

  i = atoi (args[1]);
  printf ("psh: %d bytes to alloc\n", i);
  printf ("ret=0x%x\n", malloc (i));
}

void 
psh_free ()
{
  int i;

  i = atoi (args[1]);
  printf ("freeing 0x%x\n", i);
  free ((void *) i);
}

struct command_struct psh_command[] =
{
  {"help", "Writes this table.", psh_help},
  {"dump", "[off len] Performs memory dump.", psh_dump},
  {"termtest", "Shows nancy terminal inbuilt demo.", psh_termtest},
  {"clear", "Clears the screen.", psh_cls},
  {"mousetest", "Mouse testing proc.", psh_mousetest},
  {"open", "Opens specified file.", psh_open},
  {"close", "Closes specified file.", psh_close},
  {"dup", "[fd] Dups a fd.", psh_dup},
  {"write", "[fd str] Writes a string to fd.", psh_write},
  {"rm", "[file] Erases file.", psh_rm},
  {"cd", "Changes directory.", psh_cd},
  {"clone", "Clones psh.", psh_clone},
  {"ls", "List content of current directory.", psh_ls},
  {"cat", "Cats a file.", psh_cat},
  {"seek", "[fd off] Standard lseek(). whence=SEEK_SET.", psh_seek},
  {"tell", "[fd] Tells file's pointer position.", psh_tell},
  {"create", "[name] Creates and opens new empty file.", psh_create},
  {"mkdir", "[name] Create directory.", psh_mkdir},
  {"rmdir", "[name] Removes directory.", psh_rmdir},
  {"stat", "[fd] Stats a file by fd.", psh_stat},
  {"run", "[fname] Runs a program.", psh_run},
  {"touch", "[fname] Touches a file/dir.", psh_touch},
  {"mount", "[what where fs]", psh_mount},
  {"umount", "[what]", psh_umount},
  {"exit", "Quits psh.", psh_exit},
  {"sync", "Sync all block devices.", sync},
  {"malloc", "[bts] Allocates bts bytes of memory.", psh_malloc},
  {"free", "[ptr] Frees memory specified by ptr.", psh_free},
  {NULL, NULL, NULL}
};

int
main ()
{
  int i;

  printf (ID "\n");
  do
    {
      printf ("%s>", getwd (curdir));
      gets (buff);
      putchar ('\n');
      parse_args ();
      i = 0;
      while (psh_command[i].action && strcmp (psh_command[i].name, args[0]))
	i++;
      if (psh_command[i].action)
	psh_command[i].action ();
      else
	printf ("unknown command\n");
    }
  while (!fl_exit);

  printf ("Exiting psh...\n");

  return 0;
}

void
psh_help ()
{
  int i = 0;

  if (args[1][0])
    {
      while (psh_command[i].action && strcmp (args[1], psh_command[i].name))
	i++;
      if (psh_command[i].action)
	{
	  printf (psh_command[i].help);
	  putchar ('\n');
	}
      else
	printf ("unknown command %s\n", args[1][0]);
    }

  printf ("psh commands:\n\n");
  while (psh_command[i].action)
    {
      printf ("%-10s   %-50s\n", psh_command[i].name, psh_command[i].help);
      if (i == 23 && !psh_more ())
	break;
      i++;
    }
  putchar ('\n');
}
