#include "q.h"

int
load_file (EWIN * ew)
{
  int f, bts;
  char buff[MAXLINE + 1], *beg, *end;

  f = open (ew->filename, O_RDONLY);

  ew->first_line = NULL;
  ew->last_line = NULL;

  ew->lines = 0;

  ew->display_line = NULL;
  ew->current_line = NULL;

  ew->begx = 0;
  ew->begy = 0;
  ew->curx = 0;
  ew->cury = 0;
  ew->fl_dirt = 0;
  ew->fl_overwrite = 0;
  ew->block_mode = BLOCK_NONE;

  ew->clip = NULL;

  if (f == -1)
    {
      printf ("file %s does not exist\n", ew->filename);
      return -1;
    }

  while (bts = read (f, buff, MAXLINE))
    {
      buff[bts] = 0;		/* strchr terminator */

      beg = buff;
      do
	{
	  add_line (ew, ew->last_line);

	  end = strchr (beg, '\n');
	  ew->last_line->length =
	    (end ==
	     NULL) ? (int) (buff + sizeof (buff) - beg) : (int) (end - beg);
	  memcpy (ew->last_line->data, beg, ew->last_line->length);
	  beg = end + 1;
	}
      while (end != NULL && end[1]);
    }

  ew->display_line = ew->first_line;
  ew->current_line = ew->first_line;

  close (f);

  return 0;
}

int
save_file (EWIN * ew, char *filename)
{
  int f, bts;
  char buff[128];
  LINE *l;

  f = open (filename, O_WRONLY | O_CREAT | O_TRUNC);
  if (f == -1)
    {
      sprintf (buff, "Cannot open %s for writing.\nerrno=%d",
	       filename, errno);
      messagebox ("Error", buff, OK_BUTTON);
      return -1;
    }

  bts = 0;
  l = ew->first_line;
  while (l != NULL)
    {
      if (write (f, l->data, l->length) != l->length)
	goto write_error;
      bts += l->length;
      if (write (f, "\n", 1) != 1)
	goto write_error;
      bts++;
      l = l->next;
    }

  close (f);

  ew->fl_dirt = 0;
  return 0;

write_error:
  sprintf (buff, "Write error occured\n%d bytes written.\nerrno=%d",
	   bts, errno);
  close (f);
  return -1;
}

int
save_as_file (EWIN * ew)
{
  char res[64];

  res[0] = 0;

  if (!querybox ("Save As", "Enter file name:", res, 64)
      && !save_file (ew, res))
    strcpy (ew->filename, res);
}
