#define DEBUG

#include <stdio.h>
#include <conio.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/stat.h>
#include "q.h"

FORM form1 = DEFAULT_FORM;

CANVAS ed_canvas =
{60, 20};

EWIN *ewin;

void
error (char *str)
{
  printf (str);
}

void
event_handler (CELL * cell, unsigned int event_type, unsigned int arg)
{
  EWIN *ew = ewin;
  CANVAS *can;
  LINE *l;
  int i, origx, origy;

  if (cell->u.canvas == &ed_canvas)
    {
      can = &ed_canvas;

      switch (event_type)
	{
	case EVENT_ONKEY:
	  switch (event.xkey)
	    {
	    case K_ESC:	/* end editing */
	      if (!ew->fl_dirt ||
		  (ew->fl_dirt &&
		   messagebox ("Quit",
			       "File was modified,\nlose changes?",
			       OK_BUTTON | CANCEL_BUTTON) == OK_BUTTON))
		{
		  default_event_handler (NULL, EVENT_CLOSEAPP, 0);
		}
	      break;

	    case K_HOME:
	      origx = CURX(ew);
	      origy = CURY(ew);

	      if (CURX(ew))
		{
		  ew->curx = 0;
		  ew->begx = 0;

		  do_block (ew, origx, origy);

		  do_draw (cell, can, ew);
		  update_line_info (ew);
		  rg_wrefresh (cell->window);
		}
	      break;

	    case K_END:
	      origx = CURX(ew);
	      origy = CURY(ew);

	      if (ew->current_line->length - ew->begx >= ew->lx)
		{		/* show end */
		  ew->begx = ew->current_line->length - ew->lx + 1;
		  ew->curx = ew->lx - 1;

		  do_block (ew, origx, origy);
		  do_draw (cell, can, ew);
		}
	      else
		{
		  ew->curx = ew->current_line->length - ew->begx;

		if(do_block (ew, origx, origy))
		  do_draw (cell, can, ew);
		   else rg_setcursor (cell->window,
				cell->x + ew->curx, cell->y + ew->cury);		  
		}

	      update_line_info (ew);
	      rg_wrefresh (cell->window);
	      break;

	    case K_PGUP:
	      origx = CURX(ew);
	      origy = CURY(ew);

	      if (rg_getkey (K_CONTROL) || rg_getkey (K_RCONTROL))
		{
		  ew->curx = 0;
		  ew->cury = 0;
		  ew->begx = 0;
		  ew->begy = 0;
		  ew->display_line = ew->first_line;
		  ew->current_line = ew->first_line;

		  do_block (ew, origx, origy);

		  do_draw (cell, can, ew);
		  update_line_info (ew);
		  rg_wrefresh (cell->window);
		}
	      break;

	    case K_PGDN:
	      origx = CURX(ew);
	      origy = CURY(ew);

	      if (rg_getkey (K_CONTROL) || rg_getkey (K_RCONTROL))
		{
		  ew->current_line = ew->last_line;
		  ew->curx = 0;
		  ew->begx = 0;
		  if (ew->lines >= ew->ly)
		    {
		      ew->begy = ew->lines - ew->ly + 1;
		      ew->cury = ew->ly - 1;
		      l = ew->last_line;
		      for (i = 0; i < ew->ly - 1; i++)
			{
			  if (l == NULL)	/* should not happen */
			    break;
			  l = l->prev;
			}
		      ew->display_line = l;
		    }
		  else
		    {
		      ew->begy = 0;
		      ew->cury = ew->lines - 1;
		    }

	        do_block (ew, origx, origy);

		  do_draw (cell, can, ew);
		  update_line_info (ew);
		  rg_wrefresh (cell->window);
		}
	      break;

	    case K_UP:
	      origx = ew->curx + ew->begx;
	      origy = ew->cury + ew->begy;

	      if (ew->current_line->prev != NULL)
		{
		  ew->current_line = ew->current_line->prev;

		  if (ew->cury)
		    {
		      ew->cury--;
		      align_cursor (cell, can, ew);
		      if (do_block (ew, origx, origy))
			do_draw (cell, can, ew);
		    }
		  else if (ew->begy)
		    {
		      ew->display_line = ew->current_line;
		      ew->begy--;
		      align_cursor (cell, can, ew);
		      do_block (ew, origx, origy);
		      do_draw (cell, can, ew);
		    }
		  else
		    {		/* place cursor at [0;0] */
		      ew->begx = 0;
		      ew->curx = 0;
		      ew->begy = 0;
		      ew->cury = 0;
		      align_cursor (cell, can, ew);
		    }

		  update_line_info (ew);
		  rg_wrefresh (cell->window);
		}
	      break;

	    case K_DOWN:
	      origx = ew->curx + ew->begx;
	      origy = ew->cury + ew->begy;

	      if (ew->current_line->next != NULL)
		{
		  ew->current_line = ew->current_line->next;

		  if (ew->cury < can->ly - 1)
		    {
		      ew->cury++;
		      align_cursor (cell, can, ew);
		      if (do_block (ew, origx, origy))
			do_draw (cell, can, ew);
		    }
		  else if (ew->begy + ew->cury < ew->lines - 1)
		    {
		      ew->begy++;
		      ew->display_line = ew->display_line->next;
		      align_cursor (cell, can, ew);
		      do_block (ew, origx, origy);
		      do_draw (cell, can, ew);
		    }
		  else
		    {		/* last line, move cursor to the end of line */
		      ew->curx = ew->current_line->length - ew->begx;
		      align_cursor (cell, can, ew);
		    }
		  update_line_info (ew);
		  rg_wrefresh (cell->window);
		}
	      break;

	    case K_LEFT:
	      origx = ew->begx + ew->curx;
	      origy = ew->begy + ew->cury;

	      if (ew->curx)
		{
		  ew->curx--;
		  rg_setcursor (cell->window, cell->x + ew->curx,
				cell->y + ew->cury);
		  update_line_info (ew);
		  if (do_block (ew, origx, origy))
		    do_draw (cell, can, ew);
		  rg_wrefresh (cell->window);
		}
	      else if (ew->begx)
		{
		  ew->begx--;
		  do_block (ew, origx, origy);
		  do_draw (cell, can, ew);
		  update_line_info (ew);
		  rg_wrefresh (cell->window);
		}
	      break;

	    case K_RIGHT:
	      origx = ew->begx + ew->curx;
	      origy = ew->begy + ew->cury;

	      if (ew->curx < MIN (can->lx - 1, ew->current_line->length))
		{
		  ew->curx++;
		  rg_setcursor (cell->window, cell->x + ew->curx,
				cell->y + ew->cury);
		  update_line_info (ew);
		  if (do_block (ew, origx, origy))
		    do_draw (cell, can, ew);
		  rg_wrefresh (cell->window);
		}
	      else if (ew->begx + ew->curx < ew->current_line->length)
		{
		  ew->begx++;
		  do_block (ew, origx, origy);
		  do_draw (cell, can, ew);
		  update_line_info (ew);
		  rg_wrefresh (cell->window);
		}
	      break;

	    case K_DELETE:
	      do_delete (cell, can, ew);
	      break;

	    case K_BACKSPACE:
	      do_backspace (cell, can, ew);
	      break;

	    case K_ENTER:
	      do_newline (cell, can, ew);
	      break;

	    case K_F2:
	      if (rg_getkey (K_LSHIFT))
		save_as_file (ew);
	      else
		save_file (ew, ew->filename);
	      break;

	    case K_INSERT:
	      if (!ew->fl_overwrite)
		{
		  ew->fl_overwrite = 1;
		  rg_showbigcursor (cell->window);
		}
	      else
		{
		  ew->fl_overwrite = 0;
		  rg_showcursor (cell->window);
		}
	      update_line_info (ew);
	      break;

	    default:

	      if (CTRL_DOWN)
		{
		  switch (event.xkey)
		    {
		    case K_X:	/* cut & copy */
		      clip_copy (ew);
		      block_remove (ew);
		      do_draw (cell, can, ew);
		      update_line_info (ew);
		      rg_wrefresh (cell->window);
		      return;

		    case K_DELETE:	/* cut */
		      block_remove (ew);
		      do_draw (cell, can, ew);
		      update_line_info (ew);
		      rg_wrefresh (cell->window);
		      return;

		    case K_C:	/* copy */
		    case K_INSERT:
		      clip_copy (ew);
		      return;

		    case K_V:	/* paste */
		      clip_paste (ew);
		      do_draw (cell, can, ew);
		      update_line_info (ew);
		      rg_wrefresh (cell->window);
		      return;
		    }
		}

	      if (SHIFT_DOWN)
		{
		  switch (event.xkey)
		    {
		    case K_INSERT:	/* paste */
		      clip_paste (ew);
		      do_draw (cell, can, ew);
		      update_line_info (ew);
		      rg_wrefresh (cell->window);
		      return;

		    case K_DELETE:	/* cut & copy */
		      clip_copy (ew);
		      block_remove (ew);
		      do_draw (cell, can, ew);
		      update_line_info (ew);
		      rg_wrefresh (cell->window);
		      return;
		    }
		}

	      if (event.key)
		{
		  insert_char (cell, can, ew, event.key);
		}
	      break;
	    }
	  break;

	case EVENT_DRAW:
	  do_draw (cell, can, ew);
	  rg_wrefresh (cell->window);
	  break;
	}
    }

  else
    default_event_handler (cell, event_type, arg);
}

int
main (int argc, char **argv)
{
  int ret;
  char *filename;
  char tmp[64];

  printf ("Qedit 1.0 (c) 2001 Ondrej Havel, argc=%d\n", argc);

  if (argc < 2)
    {
      filename = tmp;
      printf ("file to edit: ");
      gets (tmp);
      printf ("ok, opening %s\n", tmp);
    }
  else
    filename = argv[1];

  ewin = (EWIN *) malloc (sizeof (EWIN));
  if (ewin == NULL)
    {
      printf ("oom\n");
      return -1;
    }

  ewin->lx = ed_canvas.lx;
  ewin->ly = ed_canvas.ly;

  strcpy (ewin->filename, filename);

  if (ret = load_file (ewin))
    {
      free (ewin);
      return ret;
    }

  form1.lx = ed_canvas.lx + 2;
  
form1.ly = ed_canvas.ly + 2;
  
form1.event_handler = event_handler;
  
form1.cell_queue = (info_cell =
		       new_memo (0, 21, &info_memo,
				 (form1.cell_tail =
				  new_canvas (1, 1, &ed_canvas, NULL))));
  form1.caption = " Qedit ";
  
form1.current_cell = form1.cell_queue;
  
ed_canvas.magic = (void *) ewin;

  
showmodal (&form1);
  
flush_ewin (ewin);

  printf ("thanx for playing.\n");
  return 0;
}
