#ifndef Q_Q_H
#define Q_Q_H

#include <twins/twins.h>

#define SCREEN_X		80
#define SCREEN_Y		25

#define MAXLINE                 1024

#define EWIN                    struct ewindow

#define SHIFT_DOWN		(rg_getkey(K_SHIFT) || rg_getkey(K_RSHIFT))
#define CTRL_DOWN		(rg_getkey(K_CONTROL) || rg_getkey(K_RCONTROL))

#define SWAPIT(a,b)		{(a)^=(b); (b)^=(a); (a)^=b;}

#define CURX(ew)		((ew)->curx + (ew)->begx)
#define CURY(ew)		((ew)->cury + (ew)->begy)

#define LINE			struct line

LINE
  {
    char data[MAXLINE];
    int length;
    int flags;
    LINE *next;
    LINE *prev;
  };

#define BLOCK_NONE	0
#define BLOCK_LINE	1

struct ewindow
  {
    int begx, begy;		/* window beginnings */
    int curx, cury;		/* current x,y position */
    int lines;			/* line count */
    LINE *first_line;
    LINE *last_line;
    LINE *current_line;		/* line beeing edited */
    LINE *display_line;		/* first diplayed line */
    char filename[64];
    int lx, ly;
    int fl_dirt;
    int fl_overwrite;
    int block_mode;
    int block_x0, block_x1;	/* block coordinates */
    int block_y0, block_y1;
    LINE *clip;
  };

#include "file.h"
#include "draw.h"
#include "general.h"
#include "block.h"

#endif
