#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>
#include <getopt.h>
#include "z.h"

#define BSIZE	4096

int bflag, eflag, nflag, sflag, tflag, vflag, fl_raw;
int rval;
char *filename;
char buf[BSIZE];

void
do_raw_cat (FILE * fp)
{
  int nr, nw, off, wfd, rfd;
  
char *buf;

  

wfd = fileno (stdout);
  rfd = fileno (fp);
  
  
while ((nr = read (rfd, buf, BSIZE)) > 0)
    {
      
for (off = 0; off < nr; nr -= nw, off += nw)
	{
	  
if ((nw = write (wfd, buf + off, nr)) < 0)
	    {
	      
perror ("stdout");
	      
return;
	    
}
	
}
    
}
  
if (nr < 0)
    perror (filename);

}

void 
do_cat (FILE * fp)
{
  
int ch, gobble, line, prev;
  

line = gobble = 0;

  
for (prev = '\n'; (ch = getc (fp)) != EOF; prev = ch)
    {
      
if (prev == '\n')
	{
	  
if (ch == '\n')
	    {
	      
if (sflag)
		{
		  
if (!gobble && putchar (ch) == EOF)
		    
break;
		  
gobble = 1;
		  
continue;
		
}
	      
if (nflag && !bflag)
		{
		  
(void) fprintf (stdout, "%6d\t", ++line);
/*		  
if (ferror (stdout))
		    
break;*/
		
}
	    
}
	  else if (nflag)
	    {
	      
(void) fprintf (stdout, "%6d\t", ++line);
/*	      
if (ferror (stdout))
		
break;*/
	    
}
	
}
      
gobble = 0;
      
if (ch == '\n')
	{
	  
if (eflag)
	    
if (putchar ('$') == EOF)
	      
break;
	
}
      else if (ch == '\t')
	{
	  
if (tflag)
	    {
	      
if (putchar ('^') == EOF || putchar ('I') == EOF)
		
break;
	      
continue;
	    
}
	
}
      else if (vflag)
	{
	  
if (!isascii (ch))
	    {
	      
if (putchar ('M') == EOF || putchar ('-') == EOF)
		
break;
/*	      
ch = toascii (ch);*/
	    
}
	  
if (iscntrl (ch))
	    {
	      
if (putchar ('^') == EOF
		   || 
putchar (ch == '\177' ? '?' : 
ch | 0100) == EOF)
		
break;
	      
continue;
	    
}
	
}
      
if (putchar (ch) == EOF)
	
break;
    
}

}


void 
do_args (char **argv) 

{
  
FILE * fp;
  

fp = stdin;
  
filename = "stdin";
  
  while(*argv)
    {
      
if (*argv)
	{
	  
if (!strcmp (*argv, "-"))
	    
fp = stdin;
	  else if (!(fp = fopen (*argv, "r")))
	    {
	      perror (*argv);
	      
++argv;
	      
continue;
	    
}
	  
filename = *argv++;
	
}

      if (fl_raw)
	do_raw_cat (fp);
      else
	
do_cat (fp);

      
if (fp != stdin)
	
fclose (fp);
    
}

}

Z_MAIN(cat)
{
  
int ch;
  

while ((ch = getopt (argc, argv, "benstuv")) != EOF)
    
switch (ch)
      {
      
case 'b':
	
bflag = nflag = 1;	/* -b implies -n */
	
break;
      
case 'e':
	
eflag = vflag = 1;	/* -e implies -v */
	
break;
      
case 'n':
	
nflag = 1;
	
break;
      
case 's':
	
sflag = 1;
	
break;
      
case 't':
	
tflag = vflag = 1;	/* -t implies -v */
	
break;
      
case 'u':
/*	
setbuf (stdout, (char *) NULL);*/
	
break;
      
case 'v':
	
vflag = 1;
	
break;
      
case '?':
	
(void) fprintf (stderr, 
"usage: cat [-benstuv] [-] [file ...]\n");
	
exit (1);
	break;
      
}

  
argv += optind;

  fl_raw = bflag || eflag || nflag || sflag || tflag || vflag;

  do_args (argv);

  return rval;

}
