#include <stdio.h>
#include <dirent.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include "z.h"

static int kflag = 1;		/* Display in K (default) */

unsigned int
du (char *path)
{
  struct stat sb;
  DIR *dir;
  struct dirent *de;
  unsigned int tally = 0;
  char *delim;

  dir = opendir (".");
  if (dir == 0)
    {
      perror (".");
      return;
    }
  delim = path + strlen (path);

  while (de = readdir (dir))
    {
      if (stat (de->d_name, &sb) < 0)
	{
	  perror (de->d_name);
	  continue;
	}

      switch (sb.st_mode & S_IFMT)
	{
	case S_IFDIR:		/* Recurse on subdirs */
	  {
//	    int fd;

	    sprintf (delim, "/%s", de->d_name);
/*	    fd = open (".", O_RDONLY);
	    if (fd < 0)
	      {
		perror ("open(\".\")");
		return tally;
	      }*/

	    chdir (de->d_name);
	    tally += du (path);
	    chdir("..");
//	    fchdir (fd);	/* go back... */
	    *delim = '\0';
	  }
	  break;

	case S_IFREG:
	  tally += sb.st_size; /*sb.st_blocks * sb.st_blksize;*/
	  break;
	}
    }
  closedir (dir);
  printf ("%8D %s\n", kflag ? (tally / 1024) : (tally / 512), path);

  return tally;
}

Z_MAIN (du)
{
  int x, done = 0;
  char pathbuf[1024];

  for (x = 1; (x < argc) && !done; x++)
    {
      if (argv[x][0] == '-')
	{
	  switch (argv[x][1])
	    {
	    case 'k':
	      kflag = 1;
	      break;
	    case 'b':
	      kflag = 0;
	      break;
	    case '-':
	      done = 1;
	      break;
	    default:
	      fprintf (stderr, "Unknown switch: %s\n", argv[x]);
	      exit (1);
	    }
	}
      else
	break;
    }

  if (x >= argc)
    {
      strcpy (pathbuf, ".");
      du (pathbuf);
    }
  else
    {
      char cwdbuf[1024];

      getcwd (cwdbuf, sizeof (cwdbuf));
      for (; x < argc; ++x)
	{
	  if (argv[x][0] != '/')
	    chdir (cwdbuf);

	  strcpy (pathbuf, argv[x]);
	  chdir (pathbuf);
	  du (pathbuf);
	}
    }

  return 0;
}
