#include <stdio.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>
#include <errno.h>
#include <string.h>		/* patch */
#include "z.h"

void
perm_decay (int perm)
{
  if (perm & S_IFBLK)
    putchar ('b');
  else if (perm & S_IFDIR)
    putchar ('d');
  else if (perm & S_IFCHR)
    putchar ('c');
  else if (perm & S_IFLNK)
    putchar ('l');
  else if (perm & S_IROTH)
    putchar ('r');
  else
    putchar ('-');
  if (perm & S_IWOTH)
    putchar ('w');
  else
    putchar ('-');
  if (perm & S_IXOTH)
    putchar ('x');
  else
    putchar ('-');
}

Z_MAIN (ls)
{
  DIR *d;
  char c;
  int ret, fl_ext = 0;
  struct dirent *dirent;
  struct stat st;
  char *n;

  if (argc >= 2 && argv[1][0] == '-' && argv[1][1] == 'l' && !argv[1][2])
    fl_ext = 1;

  d = opendir (".");
  if (d == NULL)
    {
      printf ("ls: cannot open directory\n");
      return;
    }

/* what to do with the third argument? */
  while ((dirent = readdir (d)) != NULL)
    {
      bzero(&st, sizeof(st));		/* kernel debug patch */

      if (ret = stat (dirent->d_name, &st))
	printf ("ls: stat failed, name=%s, errno=%d\n", dirent->d_name,
		errno);

      n = dirent->d_name;

      if (n[0] == '.' && (!n[1] || (n[1] == '.' && !n[2])))
	continue;		/* skip 'dots' */

      if (fl_ext)
	{
	  if (S_ISBLK (st.st_mode))
	    c = 'b';
	  else if (S_ISDIR (st.st_mode))
	    c = 'd';
	  else
	    c = '-';		/* does c==0 terminate whole printf? */
	  printf ("%16s  %8d  %c", dirent->d_name, st.st_size, c);
	  perm_decay ((st.st_mode >> 6) & 0x07);
	  perm_decay ((st.st_mode >> 3) & 0x07);
	  perm_decay (st.st_mode & 0x07);
	}
      else
	printf (dirent->d_name);

      printf ("\n");
    }

  closedir (d);
}
