#include <stdio.h>
#include <dirent.h>
#include <sys/stat.h>
#include "z.h"

int rflag, fflag;

int do_remove (char *n);

int
cleardir ()
{
  DIR *dir;
  struct dirent *de;

  if ((dir = opendir (".")) == NULL)
    return -1;

  for (de = readdir (dir); de; de = readdir (dir))
    if (do_remove (de->d_name) && !fflag)
      break;

  closedir (dir);

  return 0;
}

int
do_remove (char *n)
{
  struct stat sb;

  if (!unlink (n))
    return;

  if (stat (n, &sb) < 0)
    {
      if (!fflag)
	{
	  perror (n);
	  return 1;
	}
      return 0;
    }

  if ((sb.st_mode & S_IFMT) != S_IFDIR)
    {
      if (!fflag)
	{
	  perror (n);
	  return 1;
	}
      return 0;
    }

  if (!rflag)
    {
      if (!fflag)
	{
	  printf ("%s: is a directory\n", n);
	  return 1;
	}
      return 0;
    }

  if (chdir (n))
    {
      if (!fflag)
	{
	  perror (n);
	  return 1;
	}
      return 0;
    }

  if (cleardir ())
    {
      if (!fflag)
	{
	  perror (n);
	  return 1;
	}
    }

  if (chdir ("..") < 0)
    {
      perror ("Return from subdir");
      return 1;
    }

  if (unlink (n))
    {
      if (!fflag)
	{
	  perror (n);
	  return 1;
	}
      return 0;
    }
}

Z_MAIN (rm)
{
  int i;

  for (i = 1; i < argc; i++)
    {
      char *p;

      if (argv[i][0] != '-')
	break;

      for (p = argv[i] + 1; *p; p++)
	{
	  switch (*p)
	    {
	    case 'r':
	      rflag = 1;
	      break;
	    case 'f':
	      fflag = 1;
	      break;
	    }
	}
    }

  while (i < argc)
    if (do_remove (argv[i++]))
      return -1;

  return 0;
}
