/*
TODO: add merging with previous chunks!
*/

#include "malloc.h"

#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

//#define DEBUG

void
free (void *ptr)
{
  int page;
  struct page_info *pi;
  struct chunk_info *ci, *ci2;

  if (ptr == NULL)
    return;

  pi = GETPI (ptr);

  if (ptr == (void *) (pi + 1))
    {
#ifdef DEBUG
      printf ("free: big alloc detected (%d pages)\n", pi->pages);
#endif

      user_free_pages (pi, pi->pages);
      return;
    }

  ci = (struct chunk_info *) (ptr - CIS);

#ifdef DEBUG
  printf ("free: small alloc, addr=0x%x, chunksize=%d\n", ptr, ci->bytes);
#endif

  pi->bytes += ci->bytes + CIS;
  ci->flags = CHUNK_FREE;

  if (pi->bytes == PAGESIZE - PIS)
    {
      page = TOPAGE (ci);

#ifdef DEBUG
      printf ("free: nice, releasing whole page 0x%x\n", TOADDR(page));
#endif

/* Release all free chunks which are on same page. */
      ci2 = chunk_head;
      while (ci2 != NULL)
	{
	  ci = ci2->next;
	  if (TOPAGE (ci2) == page)
	    unlink (ci2);
	  ci2 = ci;
	}

      user_free_pages (pi, 1);
      return;
    }

#ifdef DEBUG
  printf ("pi->bytes=%d\n", pi->bytes);
#endif

  if (!IS_LAST (ci))
    {
      ci2 = NEXT_CHUNK (ci, ci->bytes);

/* next chunk merger */
      if (IS_FREE(ci2))
	{
#ifdef DEBUG
	  printf ("free: chunk merger ci=0x%x  ci2=0x%x\n", ci, ci2);
#endif

	  unlink (ci2);

	  ci->flags = ci2->flags;	/* LAST bit overtake */
	  ci->bytes += ci2->bytes + CIS;
	}
    }

/* Link the free chunk in the queue. */
  link_in (ci);
}
