#include <sys/types.h>

#define PAGEBITS	12
#define PAGESIZE	(1 << PAGEBITS)
#define PAGIFY(x)	((x + PAGESIZE - 1) >> PAGEBITS)
#define PAGEMASK	(PAGESIZE - 1)
#define ADDRMASK	(~PAGEMASK)

#define TOPAGE(x)	((unsigned int)(x) >> PAGEBITS)
#define TOADDR(x)	((unsigned int)(x) << PAGEBITS)

#define CHUNKBITS	2
#define CHUNKSIZE	(1 << CHUNKBITS)
#define CHUNKMASK	(CHUNKSIZE - 1)
#define CHUNKIFY(s)	(((s) + CHUNKSIZE - 1) & ~CHUNKMASK)

#define MAXPERPAGEALLOC	(PAGESIZE - sizeof(struct page_info) - sizeof(struct chunk_info) - CHUNKSIZE)

#define CHUNK_FREE	0x00EE
#define CHUNK_USED	0x00ED
#define CHUNK_LAST	0x1100	/* last chunk in page */
#define LAST_MASK	0xFF00

#define IS_LAST(c)	(((c)->flags & CHUNK_LAST) == CHUNK_LAST)
#define IS_FREE(c)	(((c)->flags & CHUNK_FREE) == CHUNK_FREE)
#define IS_USED(c)	(((c)->flags & CHUNK_USED) == CHUNK_USED)

#define NEXT_CHUNK(c,s)	((struct chunk_info *) ((void *) (c) + CIS + (s)))

#define GETPI(ci)	((struct page_info *)((u32)ci & ADDRMASK))

#define CIS		sizeof(struct chunk_info)
#define PIS		sizeof(struct page_info)

struct chunk_info
{
  u16 flags;			/* free, used, last */
  s16 bytes;			/* size of data-part (without this header) */
  struct chunk_info *next;	/* next (bigger) free chunk in queue */
  struct chunk_info *prev;	/* prev (smaller) free in queue */
};

struct page_info
{
  u16 pages;			/* continuous pages ? */
  u16 bytes;			/* free bytes on page */
};

extern struct chunk_info *chunk_head;

void link_in (struct chunk_info *);
