#include <string.h>
#include <twins/twins.h>

#define ALL          0		/* total draw */
#define ACTIVATE     1		/* draw activated only */
#define DEACTIVATE   2		/* draw deactivated only */

void
button_draw (CELL * cell, BUTTON * b, int todo)
{
  char fl_hi;
  int i, r_len, x_pos, y_pos, len, attr, lx, ly;
  WINDOW *w = cell->window;

/* get real length of text */
  r_len = strlen (b->text);
  len = r_len;

  for (i = 0; i < r_len; i++)
    if (b->text[i] == '~')
      len--;

  if (b->lx <= 0)
    lx = len + 2;
  else
    lx = b->lx;
  if (b->ly <= 0)
    ly = 1;
  else
    ly = b->ly;

  if (todo == ALL)
    {
      rg_hidecursor (w);
      rg_box (w, cell->x, cell->y, lx, ly, ATTR_BUTTON);
      rg_putch (w, cell->x + lx, cell->y + ly - 1, ATTR_BUTTON_SHADE, (u8)'');

      for (i = 1; i < ly - 1; i++)
	rg_putch (w, cell->x + lx, cell->y + ly + i, ATTR_BUTTON_SHADE, (u8)'');
      for (i = 0; i < lx; i++)
	rg_putch (w, cell->x + 1 + i, cell->y + ly, ATTR_BUTTON_SHADE, (u8)'');
    }

  x_pos = cell->x + ((lx - len) >> 1);
  y_pos = cell->y + (ly >> 1);

  if (cell->disabled)
    attr = ATTR_DISABLED_BUTTON;
  else if (cell->activated || todo == ACTIVATE)
    attr = ATTR_ACTIVATED_BUTTON;
  else
    attr = ATTR_BUTTON;

  fl_hi = 0;
  for (i = 0; i < r_len; i++)
    if (b->text[i] == '~')
      fl_hi ^= 1;
    else
      rg_putch (w, x_pos++, y_pos, fl_hi ? ATTR_HI_BUTTON : attr, b->text[i]);
}

void
button_handler (CELL * cell, unsigned int event_type, unsigned int arg)
{
  int todo = 0;

  switch (event_type)
    {
    case EVENT_DEACTIVATE:
      todo++;
    case EVENT_ACTIVATE:
      todo++;
    case EVENT_DRAW:
      button_draw (cell, cell->u.button, todo);
      rg_wrefresh (cell->window);
      break;
    }
}
